/*

  Sin wave
  MPU: AVR64DB32/AVR64DD32

 MaiaR create
  maiar_create@zeus.eonet.ne.jp

  DAC register direct  10bit sample
  
*/

void dac(int a){
  DAC0.DATA = a << 6;
}


void setup() {
  VREF.DAC0REF = 0x85;
              // 0x0- The reference is automatically enabled when needed (default)
              // 0x8- The reference is always on
              // 0x-0 Internal 1.024V reference (default)
              // 0x-1 Internal 2.048V reference
              // 0x-2 Internal 4.096V reference
              // 0x-3 Internal 2.500V reference
              // 0x-5 VDD as reference
              // 0x-6 External reference from the VREFA pin
  DAC0.CTRLA = 0x41;
              // bit7 RUNSTDBY Run in Standby Mode
              // bit6 OUTEN Output Buffer Enable
              // bit0 ENABLE DAC Enable
}

void loop() {
  static int rad = 0;
  
  dac((int)((sin(2.0 * PI * rad / 256)) * 511 + 512));

  rad++;
  if (rad >= 256){
    rad = 0;
  }
  
  delay(1);
}
